
/*	Resource Id's */

#define	rVScroll				1024
#define	rHScroll				1025
#define rPredScroll				1026
#define rAboutScroll			1027

/* Dialogs */

#define rUserAlert				1024
#define rFileErrorDialog		1025
#define rPrimeTherm				1026

#define rPrefs					1027
#define iOk						1
#define iCancel					2
#define iFreqPrompt				3
#define iFreqPop				4
#define iOrderPrompt			5
#define iOrderPop				6
#define iStartUpEdit			8
#define iStopAtCRBox			9
#define iShowSpcTabBox			10
#define	iPrimeButton			11
#define iZeroButton				12
#define iUserItem				13

#define rSFPGetFileDLOG			1028
#define iOpenPrimeButton		11
#define iOpenClearButton		12

#define rGetFileNoneDLOG		1029
#define iNoneButton				11

#define rRevertAlert			1030

#define rCloseAlert				1031
#define	iYes					1
#define iCancel					2
#define iNo						3

#define rPrefChanges			1032
#define rOutOfRange				1033
#define rBigOrder				1034
#define rLowMems				1035
#define	prDlogID				1036		/* printing dialog */
#define	noPagesID				1037		/* no pages in range alert */
#define	pageSetupID				1038		/* extra items for Page Setup dlog */
#define	illegalSizeID			1039		/* illegal font size alert */
#define	marTooBigID				1040		/* margins too big alert */
#define	truncRightID			1041		/* page box too narrow alert */
#define	truncBottomID			1042		/* page box too short alert */




#define	tconID				128		/* TCON resource id */



#define rTermWindow				1024
#define rPredictWindow			1025
#define rAboutWin				1026

#define	rMoveBarCursor			1024

#define rNameStrings			1024
#define iPrefsName				1
#define iPromptStr				2
#define iDefNameStr				3
#define	ihlpDocTmpl				4
#define	ihlpDocTitle			5
#define iTConTitle				6


#define rPrefType				'PREF'
#define	rPrefID					1024

#define rMenuBar				1024

#define	mApple					128		/* Apple menu */
#define	iAbout					1

#define	mFile					129		/* File menu */
#define	iNew					1
#define iOpen					2
#define iPrime					3
#define	iClose					5
#define iSave					6
#define iSaveAs					7
#define	iRevert					8
#define	iPageSetup				10
#define	iPrint					11
#define	iQuit					13

#define	mEdit					130		/* Edit menu */
#define	iUndo					1
#define	iCut					3
#define	iCopy					4
#define	iPaste					5
#define	iClear					6

#define mOptions				131		/* Options Menu */
#define iModelOpts				1

#define mFreqPop				1024

#define mOrderPop				1025

/* Hierarchical Menus */

#define kHMenuCount				0		


/* Character Information */

#define kFontName "\p.RK Monaco"
#define kSpSpec		240
#define kTabSpec	247
#define kCrSpec		248

/*  Constants  */
#define	kSysEnvironsVersion		1
#define	kOSEvent				app4Evt	/* event used by MultiFinder */
#define	kSuspendResumeMessage	1		/* high byte of suspend/resume event message */
#define	kResumeMask				1		/* bit of message field for resume vs. suspend */
#define	kMouseMovedMessage		0xFA	/* high byte of mouse-moved event message */
#define kExtremeNeg				-32768
#define kExtremePos				(32767 - 1) /* required to address an old region bug */
#define kPrefSize				1400
#define kMinSize				1000
#define	kTESlop					1024
#define kControlInvisible		0
#define kControlVisible			0xFF
#define kScrollbarWidth			16
#define kScrollbarAdjust		(kScrollbarWidth - 1)
#define kScrollTweek			2
#define	kMaxDocWidth			576
#define	kMinDocDim				64
#define kMinPredWidth			140
#define kMinPredHeight			64
#define	kMaxTELength			32000
#define kButtonScroll			4
#define kTextMargin				2
#define kLeftSlop				13
#define kRightSlop				5
#define kBotSlop				5
#define kCrChar					13
#define kDelChar				8
#define	kMaxOpenDocuments		1
#define kCreator				'RKMJ'
#define kFileType				'TEXT'

/* The following are indicies into STR# resources. */

#define	rErrStrings				1025


#define	eWrongMachine			1
#define	eSmallSize				2
#define	eNoMemory				3
#define	eNoSpaceCut				4
#define	eNoCut					5
#define	eNoCopy					6
#define	eExceedPaste			7
#define	eNoSpacePaste			8
#define	eNoWindow				9
#define	eExceedChar				10
#define	eNoPaste				11
#define eNoInitMems				12
#define eCantZero				13
#define eCantPrime				14
#define eDiskFull				15
#define eFileLocked				16
#define	eUnexpectedSave			17



/* these #defines are used to set enable/disable flags of a menu */

#define AllItems	0b1111111111111111111111111111111	/* 31 flags */
#define NoItems		0b0000000000000000000000000000000
#define MenuItem1	0b0000000000000000000000000000001
#define MenuItem2	0b0000000000000000000000000000010
#define MenuItem3	0b0000000000000000000000000000100
#define MenuItem4	0b0000000000000000000000000001000
#define MenuItem5	0b0000000000000000000000000010000
#define MenuItem6	0b0000000000000000000000000100000
#define MenuItem7	0b0000000000000000000000001000000
#define MenuItem8	0b0000000000000000000000010000000
#define MenuItem9	0b0000000000000000000000100000000
#define MenuItem10	0b0000000000000000000001000000000
#define MenuItem11	0b0000000000000000000010000000000
#define MenuItem12	0b0000000000000000000100000000000
#define MenuItem13	0b0000000000000000001000000000000
#define MenuItem14	0b0000000000000000010000000000000
#define MenuItem15	0b0000000000000000100000000000000
#define MenuItem16	0b0000000000000001000000000000000
#define MenuItem17	0b0000000000000010000000000000000
#define MenuItem18	0b0000000000000100000000000000000
#define MenuItem19	0b0000000000001000000000000000000
#define MenuItem20	0b0000000000010000000000000000000
#define MenuItem21	0b0000000000100000000000000000000
#define MenuItem22	0b0000000001000000000000000000000
#define MenuItem23	0b0000000010000000000000000000000
#define MenuItem24	0b0000000100000000000000000000000
#define MenuItem25	0b0000001000000000000000000000000
#define MenuItem26	0b0000010000000000000000000000000
#define MenuItem27	0b0000100000000000000000000000000
#define MenuItem28	0b0001000000000000000000000000000
#define MenuItem29	0b0010000000000000000000000000000
#define MenuItem30	0b0100000000000000000000000000000
#define MenuItem31	0b1000000000000000000000000000000

#define HWCfgFlags		0xB22	/* Low memory global used to check if A/UX is running */

