#   File:       rk.make
#   Target:     rk
#   Sources:    Init.c Main.c Rk.r RK_BUTTON.C RK_FILE.C
#   Created:    Sunday, July 30, 1989 3:16:11 PM

COPTIONS = -sym off
POPTIONS = -sym off
LOPTIONS = -sym off

Init.c.o  Init.c Rk.h Structs.h
	 C {COPTIONS} Init.c 
Main.c.o  Main.c Rk.h Structs.h Offscreen.h
	 C {COPTIONS} Main.c
Files.c.o  Files.c
	 C {COPTIONS} Files.c
rk  Rk.r Rk.h picts
	Rez Rk.r -append -o rk
rk  Fonts.r
	Rez Fonts.r -append -o rk
RK_BUTTON.C.o  RK_BUTTON.C Rk.h Structs.h
	 C {COPTIONS} RK_BUTTON.C
RK_FILE.C.o  RK_FILE.C Rk.h Structs.h
	 C {COPTIONS} RK_FILE.C
Utils.c.o  Utils.c
	 C {COPTIONS} Utils.c
Printing.c.o  Printing.c
	 C {COPTIONS} Printing.c

AdjustCursor.c.o  AdjustCursor.c
	 C {COPTIONS} AdjustCursor.c

Glue.a.o  Glue.a

Offscreen.p.o  Offscreen.p rk.make
	Pascal {POPTIONS} Offscreen.p

hlp.c.o  hlp.c rep.h rpp.h utl.h hlp.h doc.h
	C {COPTIONS} hlp.c
rep.c.o  rep.c rep.h utl.h doc.h
	C {COPTIONS} rep.c
rpp.c.o  rpp.c rpp.h utl.h doc.h
	C {COPTIONS} rpp.c
utl.c.o  utl.h utl.c
	C {COPTIONS} utl.c
help.c.o  help.c
	C {COPTIONS} help.c

SOURCES = Init.c Main.c Rk.r RK_BUTTON.C RK_FILE.C Glue.a Offscreen.p Files.c Utils.c 
		  Printing.c AdjustCursor.c hlp.c rep.c rpp.c utl.c help.c


OBJECTS = Init.c.o Main.c.o RK_BUTTON.C.o RK_FILE.C.o Glue.a.o Offscreen.p.o Files.c.o 
		  Utils.c.o Printing.c.o AdjustCursor.c.o hlp.c.o rep.c.o rpp.c.o utl.c.o help.c.o
		  


rk  doc wrap cvrt picts
	wrap -r 335 -p < doc >wraptemp 
	cvrt wraptemp -o rk -i 200 -t 128 -g 128 -c 128 
		-p picts -w 345 -h 12
	delete wraptemp

rk  ldf.c.o
	Link -rt LDEF=128 -m MYLIST 
	 	ldf.c.o 
		"{Libraries}"Interface.o 
		-o rk

rk  {OBJECTS}
	Link -w -t APPL -c RKMJ -mf {LOPTIONS}
		{OBJECTS} 
		"{CLibraries}"CRuntime.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
		"{CLibraries}"CSANELib.o 
		"{CLibraries}"Math.o 
		"{CLibraries}"CInterface.o 
		"{Libraries}"ToolLibs.o 
		"{Libraries}"PerformLib.o 
		"{PLibraries}"PasLib.o 
		-o rk
	SetFile -a B rk
	SetVersion rk -t 'vers' -rezsource Rk.r -x
	Beep

#	wrap tool.		
		
wrap.c.o  wrap.c
	C {COptions} wrap.c -w
	
wrapObjects = wrap.c.o

wrap  {wrapObjects}
	Link -w -c 'MPS ' -t MPST 
		{wrapObjects} 
		"{Libraries}"stubs.o 
		"{CLibraries}"CRuntime.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
		"{CLibraries}"CInterface.o 
		-o wrap
		
#	cvrt tool.		
		
cvrt.c.o  cvrt.c doc.h
	C {COptions} cvrt.c
	
cvrtObjects = cvrt.c.o

cvrt  {cvrtObjects}
	Link -w -c 'MPS ' -t MPST 
		{cvrtObjects} 
		"{Libraries}"stubs.o 
		"{CLibraries}"CRuntime.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
		"{CLibraries}"CInterface.o 
		-o cvrt
