#include "Types.r"
#include "SysTypes.r"
#include "Rk.h"
#include "acur.r"
#define SMALL
#define VERTICAL

include	"picts";

resource 'vers' (1) {
	0x01, 0x00, alpha, 0x10, verUS,                          /* version numbers */
	"1.0a210",                                               /* short string    */
	"The Reactive Keyboard, University of Calgary 1.0a210"   /* long string     */
};

resource 'vers' (2) {
	0x01, 0x00, alpha, 0x10, verUS,                          /* version numbers */
	"1.0a210",                                               /* short string    */
	"The Reactive Keyboard, University of Calgary 1.0a210"   /* long string     */
};


type 'RKMJ' {
	pstring;
};


resource 'RKMJ' (0) {
	"The Reactive Keyboard, University of Calgary."
};


resource 'ICN#' (128, "APPL") {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 F3FF FC00 0400 0300 F5AA A880 0400 0040 F555 5520 0400 0010 F5AA AA90"
		$"0400 0020 F55F FF40 0400 0080 F400 0300 03FF FC",
		/* [2] */
		$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000"
		$"0000 0000 F3FF FC00 07FF FF00 F7FF FF80 07FF FFC0 F7FF FFE0 07FF FFF0 F7FF FFF0"
		$"07FF FFE0 F7FF FFC0 07FF FF80 F7FF FF00 03FF FC"
	}
};

resource 'ICN#' (129,"TEXT") {
	{	/* array: 2 elements */
		/* [1] */
		$"03FF FFFF 0600 0001 0A00 0001 1200 0001 2200 0001 4200 0001 FE00 0001 8000 0001"
		$"8000 0001 8000 0001 8000 0001 BCFF FF01 8100 00C1 BD6A AA21 8100 0011 BD55 5549"
		$"8100 0005 BD6A AAA5 8100 0009 BD57 FFD1 8100 0021 BD00 00C1 80FF FF01 8000 0001"
		$"8000 0001 8000 0001 8000 0001 8000 0001 8000 0001 8000 0001 8000 0001 FFFF FFFF",
		/* [2] */
		$"03FF FFFF 07FF FFFF 0FFF FFFF 1FFF FFFF 3FFF FFFF 7FFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ICN#' (130, "PREF") {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 F3FF FC00"
		$"0400 0300 F5AA A880 0400 0040 F555 5520 0400 0010 F5AA AA90 0400 0020 F55F FF40"
		$"0400 0080 F400 0300 03FF FC00 0000 0000 0000 0000 0000 0000 1C00 0C00 0A00 1000"
		$"0AB3 3CE0 0C45 9180 0846 1060 1CE3 BDC0",
		/* [2] */
		$"0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 0000 F3FF FC00"
		$"07FF FF00 F7FF FF80 07FF FFC0 F7FF FFE0 07FF FFF0 F7FF FFF0 07FF FFE0 F7FF FFC0"
		$"07FF FF80 F7FF FF00 03FF FC"
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	""
};

resource 'FREF' (129) {
	'TEXT',
	1,
	""
};

resource 'FREF' (130) {
	'PREF',
	2,
	""
};

resource 'BNDL' (132) {
	'RKMJ',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, 128,
			/* [2] */
			1, 129,
			/* [3] */
			2, 130
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, 128,
			/* [2] */
			1, 129,
			/* [3] */
			2, 130
		}
	}
};


resource 'MENU' (mApple,"Apple", preload) {
	mApple, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable dashed line, enable About and DAs */
	enabled, apple,
	{
		"About RK",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mFile,"File", preload) {
	mFile, textMenuProc,
	MenuItem13,				/* enable Quit only, program enables others */
	enabled, "File",
	{
		"New",
			noicon, "N", nomark, plain;
		"Open",
			noicon, "O", nomark, plain;
		"Prime from file",
			noicon,	nokey,nomark,plain;
		"-",
			noicon, nokey, nomark, plain;
		"Close",
			noicon, "W", nomark, plain;
		"Save",
			noicon, "S", nomark, plain;
		"Save As",
			noicon, nokey, nomark, plain;
		"Revert",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Page Setup",
			noicon, nokey, nomark, plain;
		"Print",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Quit",
			noicon, "Q", nomark, plain
	}
};

resource 'MENU' (mEdit,"Edit", preload) {
	mEdit, textMenuProc,
	NoItems,				/* disable everything, program does the enabling */
	enabled, "Edit",
	 {
		"Undo",
			noicon, "Z", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Cut",
			noicon, "X", nomark, plain;
		"Copy",
			noicon, "C", nomark, plain;
		"Paste",
			noicon, "V", nomark, plain;
		"Clear",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mOptions, "Options") {
	mOptions,
	textMenuProc,
	allEnabled,
	enabled,
	"Options",
	{
		"Model Preferences", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (mFreqPop, "Frequency Popup") {
	mFreqPop,
	textMenuProc,
	allEnabled,
	enabled,
	"Ignored",
	{
		"2",	noIcon, noKey, noMark, plain,
		"4",	noIcon, noKey, noMark, plain,
		"8",	noIcon, noKey, noMark, plain,
		"16",	noIcon, noKey, noMark, plain,
		"32",	noIcon, noKey, noMark, plain,
		"64",	noIcon, noKey, noMark, plain,
		"128",	noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (mOrderPop, "Order Popup") {
	mOrderPop,
	textMenuProc,
	allEnabled,
	enabled,
	"Ignored",
	{
		"2",	noIcon, noKey, noMark, plain,
		"3",	noIcon, noKey, noMark, plain,
		"4",	noIcon, noKey, noMark, plain,
		"5",	noIcon, noKey, noMark, plain,
		"6",	noIcon, noKey, noMark, plain,
		"7",	noIcon, noKey, noMark, plain,
		"8",	noIcon, noKey, noMark, plain,
		"9",	noIcon, noKey, noMark, plain,
		"10",	noIcon, noKey, noMark, plain
	}
};

resource 'MBAR' (rMenuBar, "Menu Bar") {
	{	/* array MenuArray: 4 elements */
		/* [1] */
		mApple,
		/* [2] */
		mFile,
		/* [3] */
		mEdit,
		/* [4] */
		mOptions,
	}
};


resource 'ALRT' (rUserAlert, purgeable) {
	{40, 20, 150, 260},
	rUserAlert,
	{ /* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};


resource 'DITL' (rUserAlert, purgeable) {
	{ /* array DITLarray: 3 elements */
		/* [1] */
		{80, 150, 100, 230},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 60, 60, 230},
		StaticText {
			disabled,
			"Error. ^0."
		},
		/* [3] */
		{8, 8, 40, 40},
		Icon {
			disabled,
			2
		}
	}
};

resource 'DITL' (rPrefs) {
	{	/* array DITLarray: 13 elements */
		/* [1] */
		{145, 46, 165, 106},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{145, 119, 165, 179},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{4, 3, 26, 150},
		StaticText {
			disabled,
			"Maximum Frequency:"
		},
		/* [4] */
		{4, 156, 20, 210},
		UserItem {
			enabled
		},
		/* [5] */
		{30, 3, 52, 151},
		StaticText {
			disabled,
			"Model Order:"
		},
		/* [6] */
		{30, 156, 46, 210},
		UserItem {
			enabled
		},
		/* [7] */
		{61, 3, 82, 149},
		StaticText {
			disabled,
			"Startup Amount:"
		},
		/* [8] */
		{59, 156, 79, 216},
		EditText {
			enabled,
			"32000"
		},
		/* [9] */
		{87, 3, 109, 201},
		CheckBox {
			enabled,
			"Stop predictions at Return"
		},
		/* [10] */
		{112, 3, 133, 181},
		CheckBox {
			enabled,
			"Show Space, Tab and CR"
		},
		/* [11] */
		{30, 229, 55, 312},
		Button {
			enabled,
			"Prime File"
		},
		/* [12] */
		{64, 229, 115, 312},
		Button {
			enabled,
			"Zero\nFrequency\nFile"
		},
		/* [13] */
		{145, 46, 165, 106},
			userItem {enabled}
	}
};

resource 'ALRT' (rRevertAlert, purgeable) {
	{100, 110, 208, 402},
	rRevertAlert,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'DITL' (rRevertAlert, purgeable) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{80, 198, 98, 272},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{80, 20, 98, 94},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{10, 70, 75, 272},
		StaticText {
			disabled,
			"Do you want to discard changes made to "
			"^0?"
		},
		/* [4] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			2
		}
	}
};
resource 'ALRT' (rCloseAlert, purgeable) {
	{100, 110, 220, 402},
	rCloseAlert,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};

resource 'DITL' (rCloseAlert, purgeable) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{58, 25, 76, 99},
		Button {
			enabled,
			"Yes"
		},
		/* [2] */
		{86, 195, 104, 269},
		Button {
			enabled,
			"Cancel"
		},
		/* [3] */
		{86, 25, 104, 99},
		Button {
			enabled,
			"No"
		},
		/* [4] */
		{12, 20, 45, 277},
		StaticText {
			disabled,
			"Save changes to ^0 before ^1?"
		}
	}
};

resource 'ALRT' (rPrefChanges) {
	{40, 40, 178, 258},
	rPrefChanges,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (rPrefChanges) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{100, 74, 120, 134},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{3, 3, 87, 215},
		StaticText {
			enabled,
			"You have made changes which will not tak"
			"e effect until you quit."
		}
	}
};

resource 'ALRT' (rOutOfRange) {
	{40, 40, 178, 258},
	rOutOfRange,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (rOutOfRange) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{100, 74, 120, 134},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{3, 3, 87, 215},
		StaticText {
			enabled,
			"The value ^0 is not in the range ^1 to ^2."
		}
	}
};

resource 'ALRT' (rBigOrder) {
	{40, 40, 178, 258},
	rBigOrder,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (rBigOrder) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{100, 74, 120, 134},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{3, 3, 87, 215},
		StaticText {
			enabled,
			"Values for Model Order larger than 10 may be very slow."
		}
	}
};


resource 'ALRT' (rLowMems) {
	{40, 40, 178, 258},
	rLowMems,
	{
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (rLowMems) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{100, 74, 120, 134},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{3, 60, 88, 214},
		StaticText {
			enabled,
			"Memory is very low.  Please save your file and quit."
		}
	}
};

resource 'DLOG' (rSFPGetFileDLOG, purgeable) {
	{0, 0, 200, 349},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	rSFPGetFileDLOG,
	""
};

resource 'DITL' (rSFPGetFileDLOG, purgeable) {
	{	/* array DITLarray: 12 elements */
		/* [1] */
		{138, 256, 156, 336},
		Button {
			enabled,
			"Open"
		},
		/* [2] */
		{0, 1211, 80, 1229},
		Button {
			enabled,
			"Hidden"
		},
		/* [3] */
		{163, 256, 181, 336},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{39, 252, 59, 347},
		UserItem {
			disabled
		},
		/* [5] */
		{68, 256, 86, 336},
		Button {
			enabled,
			"Eject"
		},
		/* [6] */
		{93, 256, 111, 336},
		Button {
			enabled,
			"Drive"
		},
		/* [7] */
		{39, 12, 180, 230},
		UserItem {
			enabled
		},
		/* [8] */
		{39, 229, 180, 245},
		UserItem {
			enabled
		},
		/* [9] */
		{124, 252, 125, 340},
		UserItem {
			disabled
		},
		/* [10] */
		{0, 1172, 101, 1268},
		StaticText {
			disabled,
			""
		},
		/* [11] */
		{1, 14, 20, 142},
		CheckBox {
			enabled,
			"Prime From File"
		},
		/* [12] */
		{19, 14, 38, 234},
		CheckBox {
			enabled,
			"Clear Memory Before Priming"
		}
	}
};


resource 'DLOG' (rGetFileNoneDLOG, purgeable) {
	{0, 0, 224, 352},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	rGetFileNoneDLOG,
	""
};
resource 'DITL' (rGetFileNoneDLOG, purgeable) {
	{	/* array DITLarray: 11 elements */
		/* [1] */
		{138, 256, 156, 336},
		Button {
			enabled,
			"Open"
		},
		/* [2] */
		{0, 1211, 80, 1229},
		Button {
			enabled,
			"Hidden"
		},
		/* [3] */
		{188, 256, 206, 336},
		Button {
			enabled,
			"Cancel"
		},
		/* [4] */
		{39, 252, 59, 347},
		UserItem {
			disabled
		},
		/* [5] */
		{68, 256, 86, 336},
		Button {
			enabled,
			"Eject"
		},
		/* [6] */
		{93, 256, 111, 336},
		Button {
			enabled,
			"Drive"
		},
		/* [7] */
		{39, 12, 206, 230},
		UserItem {
			enabled
		},
		/* [8] */
		{39, 229, 206, 245},
		UserItem {
			enabled
		},
		/* [9] */
		{124, 252, 125, 340},
		UserItem {
			disabled
		},
		/* [10] */
		{0, 1172, 101, 1268},
		StaticText {
			disabled,
			""
		},
		/* [11] */
		{163, 256, 181, 336},
		Button {
			enabled,
			"None"
		}
	}
};
resource 'DLOG' (prDlogID) {
	{0, 0, 75, 385},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	prDlogID,
	""
};

resource 'DITL' (prDlogID) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{15, 15, 35, 370},
		StaticText {
			disabled,
			"Printing ^0."
		},
		/* [2] */
		{40, 15, 60, 370},
		StaticText {
			disabled,
			"To cancel, hold down the \$11 key and type a period (.)."
		}
	}
};
/* No pages to print alert. */

resource 'ALRT' (noPagesID) {
	{0, 0, 82, 370},
	noPagesID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (noPagesID) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{52, 300, 72, 360},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 74, 39, 360},
		StaticText {
			disabled,
			"You selected the page range ^0 through ^1.  "
			"There are no pages in this range."
		}
	}
};

resource 'DITL' (PageSetupID) {
	{	/* array DITLarray: 16 elements */
		/* [1] */
		{10, 5, 11, 465},
		UserItem {
			disabled
		},
		/* [2] */
		{38, 14, 152, 176},
		UserItem {
			enabled
		},
		/* [3] */
		{41, 188, 57, 231},
		EditText {
			disabled,
			""
		},
		/* [4] */
		{70, 185, 152, 234},
		UserItem {
			enabled
		},
		/* [5] */
		{19, 253, 42, 462},
		CheckBox {
			enabled,
			"Print Pages in Reverse Order"
		},
		/* [6] */
		{84, 285, 100, 335},
		EditText {
			disabled,
			""
		},
		/* [7] */
		{121, 285, 137, 335},
		EditText {
			disabled,
			""
		},
		/* [8] */
		{84, 405, 100, 457},
		EditText {
			disabled,
			""
		},
		/* [9] */
		{121, 405, 137, 457},
		EditText {
			disabled,
			""
		},
		/* [10] */
		{21, 19, 36, 58},
		StaticText {
			disabled,
			"Font"
		},
		/* [11] */
		{21, 193, 36, 233},
		StaticText {
			disabled,
			"Size"
		},
		/* [12] */
		{84, 250, 105, 280},
		StaticText {
			disabled,
			"Left"
		},
		/* [13] */
		{121, 244, 142, 280},
		StaticText {
			disabled,
			"Right"
		},
		/* [14] */
		{84, 374, 107, 401},
		StaticText {
			disabled,
			"Top"
		},
		/* [15] */
		{121, 348, 142, 401},
		StaticText {
			disabled,
			"Bottom"
		},
		/* [16] */
		{56, 302, 75, 429},
		StaticText {
			disabled,
			"Margins (inches)"
		}
	}
};

/* Illegal font size alert. */

resource 'ALRT' (illegalSizeID) {
	{0, 0, 98, 370},
	illegalSizeID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (illegalSizeID) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{68, 300, 88, 360},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 74, 55, 360},
		StaticText {
			disabled,
			"The font size must be in the range ^0 "
			"through ^1.  Please correct it or click "
			"on the Cancel button."
		}
	}
};


/* Margins too big alert. */

resource 'ALRT' (marTooBigID) {
	{0, 0, 98, 370},
	marTooBigID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (marTooBigID) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{68, 300, 88, 360},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 74, 55, 360},
		StaticText {
			disabled,
			"The margins you specified are too large.  "
			"Please make them smaller or click on the "
			"Cancel button."
		}
	}
};
/* Page box too narrow alert */

resource 'ALRT' (truncRightID) {
	{0, 0, 162, 460},
	truncRightID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (truncRightID) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{132, 390, 152, 450},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 74, 39, 450},
		StaticText {
			disabled,
			"The document cannot be printed because s"
			"ome pages would be truncated on the right."
		},
		/* [3] */
		{55, 74, 119, 450},
		StaticText {
			disabled,
			"To correct this problem, use the Page Se"
			"tup command.  Make the left and right margins smaller or"
			" make the font size smaller.  You might a"
			"lso try printing with landscape orientat"
			"ion instead of portrait orientation."
		}
	}
};

/* Page box too short alert */

resource 'ALRT' (truncBottomID) {
	{0, 0, 146, 460},
	truncBottomID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'DITL' (truncBottomID) {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{116, 390, 136, 450},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{7, 74, 39, 450},
		StaticText {
			disabled,
			"The document cannot be printed because s"
			"ome pages would be truncated on the bottom."
		},
		/* [3] */
		{55, 74, 103, 450},
		StaticText {
			disabled,
			"To correct this problem, use the Page Se"
			"tup command. Make the margins smaller or"
			" make the font size smaller."
		}
	}
};


resource 'STR#' (rNameStrings) {
	{	/* array StringArray: 1 elements */
		/* [1] */
		"RK Preferences",
		"Save manual as:",
		"Rk Manual",
		"page ^2",
		"Rk Manual",
		"Table of Contents"
	}
};

resource 'STR#' (rErrStrings, purgeable) {
	{
	"You must run on 512Ke or later";
	"Application Memory Size is too small";
	"Not enough memory to run RK";
	"Not enough memory to do Cut";
	"Cannot do Cut";
	"Cannot do Copy";
	"Cannot exceed 32,000 characters with Paste";
	"Not enough memory to do Paste";
	"Cannot create window";
	"Cannot exceed 32,000 characters";
	"Cannot do Paste",
	"Ran out of Memory while initializing",
	"Cannot open Zero Frequency File",
	"Cannot open Prime File",
	"The file could not be saved because the disk is full.",
	"The file could not be saved because the old "
		"version of the file is locked.",
	"An unexpected error occurred while trying to sa"
	"ve a file."
	}
};

resource 'DITL' (rFileErrorDialog) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{92, 32, 112, 92},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{5, 25, 91, 365},
		StaticText {
			enabled,
			"A ^0File System Error has occured trying"
			" to ^1 \"^2\". (Error ^3)"
		}
	}
};

resource 'DITL' (rPrimeTherm) {
	{	/* array DITLarray: 1 elements */
		/* [1] */
		{7, 25, 54, 265},
		StaticText {
			disabled,
			"The Reactive Keyboard is Priming, please"
			" wait."
		}
	}
};


resource 'DLOG' (rFileErrorDialog, "File System Error") {
	{40, 40, 170, 418},
	dBoxProc,
	visible,
	nogoAway,
	0x0,
	1026,
	"File System Error"
};

resource 'DLOG' (rPrimeTherm, "Priming") {
	{82, 110, 190, 402},
	documentProc,
	visible,
	nogoAway,
	0x0,
	rPrimeTherm,
	"Priming"
};

resource 'DLOG' (rPrefs) {
	{40, 40, 218, 360},
	documentProc,
	invisible,
	nogoAway,
	0x0,
	rPrefs,
	"Model Preferences"
};


resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* we can background; we don't currently, but our sleep value */
								/* guarantees we don't hog the Mac while we are in the background */
	multiFinderAware,			/* this says we do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* this is definitely not a background-only application! */
	dontGetFrontClicks,			/* change this is if you want "do first click" behavior like the Finder */
	ignoreChildDiedEvents,		/* essentially, I'm not a debugger (sub-launching) */
	not32BitCompatible,			/* this app should not be run in 32-bit address space */
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024	
};

resource 'WIND' (rTermWindow, "Untitled", purgeable) {
#ifdef VERTICAL
#ifdef SMALL
	{40, 2, 340, 298},
#else
	{40, 2, 300, 440},
#endif
#else
#ifdef SMALL
	{40, 2, 227, 440},
#else
	{40, 2, 300, 440},
#endif
#endif
	zoomDocProc,
	visible,
	goAway,
	0x0,
	"Untitled"
};

resource 'WIND' (rPredictWindow, "Predictions Window", purgeable) {
#ifdef VERTICAL
#ifdef SMALL
	{40, 300, 340, 510},
#else
	{320, 2, 479, 440},
#endif
#else
#ifdef SMALL
	{246, 2, 339, 440},
#else
	{320, 2, 479, 440},
#endif
#endif
	zoomDocProc,
	visible,
	noGoAway,
	0x0,
	"Predictions Window"
};


resource 'CNTL' (rVScroll,"Text vScroll", preload, purgeable) {
#ifdef VERTICAL
#ifdef SMALL
	{-1, 281, 286, 297},
#else
	{-1, 423, 246, 439},
#endif
#else
#ifdef SMALL
	{-1, 423, 286, 439},
#else
	{-1, 423, 246, 439},
#endif
#endif
	0, visible, 0, 0, scrollBarProc, 0, ""
};


resource 'CNTL' (rHScroll, "Text hScroll",preload, purgeable) {
#ifdef VERTICAL
#ifdef SMALL
	{285, -1, 301, 282},
#else
	{40, 2, 300, 440},
#endif
#else
#ifdef SMALL
	{40, 2, 227, 440},
#else
	{40, 2, 300, 440},
#endif
#endif
	0, visible, 0, 0, scrollBarProc, 0, ""
};

resource 'CNTL' (rPredScroll,"PredScroll", preload, purgeable) {
#ifdef VERTICAL
#ifdef SMALL
	{-1, 195, 286, 211},
#else
	{-1, 423, 145, 439},
#endif
#else
#ifdef SMALL
	{-1, 423, 79, 439},
#else
	{-1, 423, 145, 439},
#endif
#endif
	0, invisible, 95, 0, scrollBarProc, 0, ""
};



resource 'CURS' (128, preload) {
	$"07 C0 1F 30 3F 08 7F 04 7F 04 FF 02 FF 02 FF FE"
	$"81 FE 81 FE 41 FC 41 FC 21 F8 19 F0 07 C0",
	$"07 C0 1F F0 3F F8 7F FC 7F FC FF FE FF FE FF FE"
	$"FF FE FF FE 7F FC 7F FC 3F F8 1F F0 07 C0",
	{7, 7}
};

resource 'CURS' (129, preload) {
	$"07 C0 1F F0 3F F8 5F F4 4F E4 87 C2 83 82 81 02"
	$"83 82 87 C2 4F E4 5F F4 3F F8 1F F0 07 C0",
	$"07 C0 1F F0 3F F8 7F FC 7F FC FF FE FF FE FF FE"
	$"FF FE FF FE 7F FC 7F FC 3F F8 1F F0 07 C0",
	{7, 7}
};

resource 'CURS' (130, preload) {
	$"07 C0 19 F0 21 F8 41 FC 41 FC 81 FE 81 FE FF FE"
	$"FF 02 FF 02 7F 04 7F 04 3F 08 1F 30 07 C0",
	$"07 C0 1F F0 3F F8 7F FC 7F FC FF FE FF FE FF FE"
	$"FF FE FF FE 7F FC 7F FC 3F F8 1F F0 07 C0",
	{7, 7}
};

resource 'CURS' (131, preload) {
	$"07 C0 18 30 20 08 70 1C 78 3C FC 7E FE FE FF FE"
	$"FE FE FC 7E 78 3C 70 1C 20 08 18 30 07 C0",
	$"07 C0 1F F0 3F F8 7F FC 7F FC FF FE FF FE FF FE"
	$"FF FE FF FE 7F FC 7F FC 3F F8 1F F0 07 C0",
	{7, 7}
};

resource 'CURS' (rMoveBarCursor, "MoveBar", preload) {
	$"00 00 01 80 01 80 01 80 01 80 11 88 31 8C 7F FE"
	$"31 8C 11 88 01 80 01 80 01 80 01 80",
	$"03 C0 03 C0 03 C0 03 C0 1B D8 3B DC 7F FE FF FF"
	$"7F FE 3B DC 1B D8 03 C0 03 C0 03 C0 03 C0",
	{7, 7}
};

resource 'acur' (0, preload) {
	{	/* array FrameArray: 4 elements */
		/* [1] */
		128,
		/* [2] */
		129,
		/* [3] */
		130,
		/* [4] */
		131
	}
};


resource 'WIND' (rAboutWin) {
	{40, 2, 335, 494},
	documentProc,
	invisible,
	goAway,
	0x0,
	"Help"
};

